EAPI EAPI_WEAK const Efl_Event_Description _EFL_IO_COPIER_EVENT_DONE =
   EFL_EVENT_DESCRIPTION("done");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_IO_COPIER_EVENT_ERROR =
   EFL_EVENT_DESCRIPTION("error");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_IO_COPIER_EVENT_PROGRESS =
   EFL_EVENT_DESCRIPTION("progress");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_IO_COPIER_EVENT_DATA =
   EFL_EVENT_DESCRIPTION("data");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_IO_COPIER_EVENT_LINE =
   EFL_EVENT_DESCRIPTION("line");

void _efl_io_copier_source_set(Eo *obj, Efl_Io_Copier_Data *pd, Efl_Io_Reader *source);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_source_set, EFL_FUNC_CALL(source), Efl_Io_Reader *source);

Efl_Io_Reader *_efl_io_copier_source_get(const Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_source_get, Efl_Io_Reader *, NULL);

void _efl_io_copier_destination_set(Eo *obj, Efl_Io_Copier_Data *pd, Efl_Io_Writer *destination);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_destination_set, EFL_FUNC_CALL(destination), Efl_Io_Writer *destination);

Efl_Io_Writer *_efl_io_copier_destination_get(const Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_destination_get, Efl_Io_Writer *, NULL);

void _efl_io_copier_line_delimiter_set(Eo *obj, Efl_Io_Copier_Data *pd, const Eina_Slice slice);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_line_delimiter_set, EFL_FUNC_CALL(slice), const Eina_Slice slice);

Eina_Slice _efl_io_copier_line_delimiter_get(const Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_line_delimiter_get, Eina_Slice, ((Eina_Slice){0}));

void _efl_io_copier_buffer_limit_set(Eo *obj, Efl_Io_Copier_Data *pd, size_t size);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_buffer_limit_set, EFL_FUNC_CALL(size), size_t size);

size_t _efl_io_copier_buffer_limit_get(const Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_buffer_limit_get, size_t, 0);

void _efl_io_copier_read_chunk_size_set(Eo *obj, Efl_Io_Copier_Data *pd, size_t size);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_read_chunk_size_set, EFL_FUNC_CALL(size), size_t size);

size_t _efl_io_copier_read_chunk_size_get(const Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_read_chunk_size_get, size_t, 0);

void _efl_io_copier_progress_get(const Eo *obj, Efl_Io_Copier_Data *pd, uint64_t *read, uint64_t *written, uint64_t *total);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_io_copier_progress_get, EFL_FUNC_CALL(read, written, total), uint64_t *read, uint64_t *written, uint64_t *total);

void _efl_io_copier_timeout_inactivity_set(Eo *obj, Efl_Io_Copier_Data *pd, double seconds);


static Eina_Error
__eolian_efl_io_copier_timeout_inactivity_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_io_copier_timeout_inactivity_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_timeout_inactivity_set, EFL_FUNC_CALL(seconds), double seconds);

double _efl_io_copier_timeout_inactivity_get(const Eo *obj, Efl_Io_Copier_Data *pd);


static Eina_Value
__eolian_efl_io_copier_timeout_inactivity_get_reflect(const Eo *obj)
{
   double val = efl_io_copier_timeout_inactivity_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_timeout_inactivity_get, double, 0);

void _efl_io_copier_done_set(Eo *obj, Efl_Io_Copier_Data *pd, Eina_Bool done);


static Eina_Error
__eolian_efl_io_copier_done_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_io_copier_done_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_io_copier_done_set, EFL_FUNC_CALL(done), Eina_Bool done);

Eina_Bool _efl_io_copier_done_get(const Eo *obj, Efl_Io_Copier_Data *pd);


static Eina_Value
__eolian_efl_io_copier_done_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_io_copier_done_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_done_get, Eina_Bool, 0);

Eina_Binbuf *_efl_io_copier_binbuf_steal(Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_io_copier_binbuf_steal, Eina_Binbuf *, NULL);

size_t _efl_io_copier_pending_size_get(const Eo *obj, Efl_Io_Copier_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_io_copier_pending_size_get, size_t, 0);

Eina_Bool _efl_io_copier_flush(Eo *obj, Efl_Io_Copier_Data *pd, Eina_Bool may_block, Eina_Bool ignore_line_delimiter);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_io_copier_flush, Eina_Bool, EINA_TRUE /* true */, EFL_FUNC_CALL(may_block, ignore_line_delimiter), Eina_Bool may_block, Eina_Bool ignore_line_delimiter);

Efl_Object *_efl_io_copier_efl_object_constructor(Eo *obj, Efl_Io_Copier_Data *pd);


Efl_Object *_efl_io_copier_efl_object_finalize(Eo *obj, Efl_Io_Copier_Data *pd);


void _efl_io_copier_efl_object_invalidate(Eo *obj, Efl_Io_Copier_Data *pd);


void _efl_io_copier_efl_object_destructor(Eo *obj, Efl_Io_Copier_Data *pd);


Eina_Error _efl_io_copier_efl_io_closer_close(Eo *obj, Efl_Io_Copier_Data *pd);


Eina_Bool _efl_io_copier_efl_io_closer_closed_get(const Eo *obj, Efl_Io_Copier_Data *pd);


Eina_Bool _efl_io_copier_efl_io_closer_close_on_exec_set(Eo *obj, Efl_Io_Copier_Data *pd, Eina_Bool close_on_exec);


Eina_Bool _efl_io_copier_efl_io_closer_close_on_exec_get(const Eo *obj, Efl_Io_Copier_Data *pd);


void _efl_io_copier_efl_io_closer_close_on_invalidate_set(Eo *obj, Efl_Io_Copier_Data *pd, Eina_Bool close_on_invalidate);


Eina_Bool _efl_io_copier_efl_io_closer_close_on_invalidate_get(const Eo *obj, Efl_Io_Copier_Data *pd);


static Eina_Bool
_efl_io_copier_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_IO_COPIER_EXTRA_OPS
#define EFL_IO_COPIER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_io_copier_source_set, _efl_io_copier_source_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_source_get, _efl_io_copier_source_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_destination_set, _efl_io_copier_destination_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_destination_get, _efl_io_copier_destination_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_line_delimiter_set, _efl_io_copier_line_delimiter_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_line_delimiter_get, _efl_io_copier_line_delimiter_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_buffer_limit_set, _efl_io_copier_buffer_limit_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_buffer_limit_get, _efl_io_copier_buffer_limit_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_read_chunk_size_set, _efl_io_copier_read_chunk_size_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_read_chunk_size_get, _efl_io_copier_read_chunk_size_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_progress_get, _efl_io_copier_progress_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_timeout_inactivity_set, _efl_io_copier_timeout_inactivity_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_timeout_inactivity_get, _efl_io_copier_timeout_inactivity_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_done_set, _efl_io_copier_done_set),
      EFL_OBJECT_OP_FUNC(efl_io_copier_done_get, _efl_io_copier_done_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_binbuf_steal, _efl_io_copier_binbuf_steal),
      EFL_OBJECT_OP_FUNC(efl_io_copier_pending_size_get, _efl_io_copier_pending_size_get),
      EFL_OBJECT_OP_FUNC(efl_io_copier_flush, _efl_io_copier_flush),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_io_copier_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_io_copier_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_io_copier_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_io_copier_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_io_closer_close, _efl_io_copier_efl_io_closer_close),
      EFL_OBJECT_OP_FUNC(efl_io_closer_closed_get, _efl_io_copier_efl_io_closer_closed_get),
      EFL_OBJECT_OP_FUNC(efl_io_closer_close_on_exec_set, _efl_io_copier_efl_io_closer_close_on_exec_set),
      EFL_OBJECT_OP_FUNC(efl_io_closer_close_on_exec_get, _efl_io_copier_efl_io_closer_close_on_exec_get),
      EFL_OBJECT_OP_FUNC(efl_io_closer_close_on_invalidate_set, _efl_io_copier_efl_io_closer_close_on_invalidate_set),
      EFL_OBJECT_OP_FUNC(efl_io_closer_close_on_invalidate_get, _efl_io_copier_efl_io_closer_close_on_invalidate_get),
      EFL_IO_COPIER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"timeout_inactivity", __eolian_efl_io_copier_timeout_inactivity_set_reflect, __eolian_efl_io_copier_timeout_inactivity_get_reflect},
      {"done", __eolian_efl_io_copier_done_set_reflect, __eolian_efl_io_copier_done_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_io_copier_class_desc = {
   EO_VERSION,
   "Efl.Io.Copier",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Io_Copier_Data),
   _efl_io_copier_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_io_copier_class_get, &_efl_io_copier_class_desc, EFL_LOOP_CONSUMER_CLASS, EFL_IO_CLOSER_INTERFACE, NULL);
